﻿Option Strict On
Imports Microsoft.Phone.Notification
Imports System.Text

Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' Constructor
    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub MainPage_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        Dim myPushChannel As HttpNotificationChannel
        Dim myChannelName As String = "KySSToastSampleChannel"
        myPushChannel = HttpNotificationChannel.Find(myChannelName)

        If myPushChannel Is Nothing = True Then
            myPushChannel = New HttpNotificationChannel(myChannelName)
            AddHandler myPushChannel.ChannelUriUpdated, AddressOf myPushChannel_ChanelUriUpdated
            AddHandler myPushChannel.ErrorOccurred, AddressOf myPushChannel_ErrorOccured

            myPushChannel.Open()
            myPushChannel.BindToShellToast()
        Else
            AddHandler myPushChannel.ChannelUriUpdated, AddressOf myPushChannel_ChanelUriUpdated
            AddHandler myPushChannel.ErrorOccurred, AddressOf myPushChannel_ErrorOccured
            MessageBox.Show(String.Format("チャネルのURI={0}", myPushChannel.ChannelUri.ToString()))
            SendUriToServer(myPushChannel.ChannelUri.ToString())
        End If
    End Sub

    Private Sub myPushChannel_ChanelUriUpdated(sender As Object, e As NotificationChannelUriEventArgs)
        Dispatcher.BeginInvoke(Sub()
                                   'System.Diagnostics.Debug.WriteLine(e.ChannelUri.ToString())
                                   MessageBox.Show(String.Format("チャネルのURI={0}", e.ChannelUri.ToString()))
                                   SendUriToServer(e.ChannelUri.ToString())
                               End Sub)
    End Sub

    Private Sub myPushChannel_ErrorOccured(sender As Object, e As NotificationChannelErrorEventArgs)
        Dispatcher.BeginInvoke(Sub()
                                   MessageBox.Show(String.Format("Push Notification {0} Errorが発生。{1}{2}{3}", e.ErrorType, e.Message, e.ErrorCode, e.ErrorAdditionalData))
                               End Sub)
    End Sub

    Private Sub SendUriToServer(myChannelUri As String)

        Dim myWebClient As New WebClient
        With myWebClient
            .Encoding = System.Text.Encoding.UTF8
            .Headers("content-type") = "application/x-www-form-urlencoded"
        End With

        AddHandler myWebClient.UploadStringCompleted, Sub(resultSender As Object, resultArgs As UploadStringCompletedEventArgs)
                                                          MessageBox.Show(resultArgs.Result)
                                                      End Sub

        '「あなたのサーバーのURI」にTileNotification_NETをアップロードしたサーバーのURIを指定してください。
        myWebClient.UploadStringAsync(New Uri("あなたのサーバーのURI/TileNotification_NET/Default.aspx", UriKind.Absolute), myChannelUri)
    End Sub
End Class
